<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Under Water Drone: bottomSurface.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Under Water Drone
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('bottom_surface_8cpp_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">bottomSurface.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="bottom_surface_8cpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="bottom_surface_8hh.html">bottomSurface.hh</a>&quot;</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160; </div>
<div class="line"><a name="l00005"></a><span class="lineno"><a class="line" href="classbottom_surface.html#a0ce3f995ccb6c47d41765aa99c3a45b6">    5</a></span>&#160;<a class="code" href="classbottom_surface.html#a0ce3f995ccb6c47d41765aa99c3a45b6">bottomSurface::bottomSurface</a>() {</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;    <span class="comment">// Open file with model coordinates of bottom surface</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;    ifstream inputFile;</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;    inputFile.open(kBottomModel_);</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;    <span class="comment">// Check if the file is open correctly</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;    <span class="keywordflow">if</span> (!inputFile.is_open()) {</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;        cerr &lt;&lt; <span class="stringliteral">&quot;Unable to load bottom model file!&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;        <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    }</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    <span class="comment">// Read all of model coordinates</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <a class="code" href="class_vector.html">Vector3D</a> point;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    <span class="keywordflow">while</span> (inputFile &gt;&gt; point) {</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        bottom_.push_back(point);</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        allCounter_++; <span class="comment">// Increase counter of total number of Vector3D objects</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        currentCounter_++; <span class="comment">// Increase counter of current number of Vector3D objects</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    }</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    inputFile.close();</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;}</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="classbottom_surface.html#abd43b419dc9f833e96fc5b7f6674b39b">   26</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classbottom_surface.html#abd43b419dc9f833e96fc5b7f6674b39b">bottomSurface::draw</a>(<span class="keyword">const</span> <span class="keywordtype">string</span> &amp;filename)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="comment">// Open file to which all coordinates will be saved</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    ofstream outputFile;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    outputFile.open(filename);</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="comment">// Check if the file is open correctly</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keywordflow">if</span> (!outputFile.is_open()) {</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        cerr &lt;&lt; <span class="stringliteral">&quot;Unable to open bottom file!&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    }</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="comment">// Save all coordinates to the result file</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i &lt; bottom_.size(); ++i) {</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        outputFile &lt;&lt; bottom_[i] &lt;&lt; endl;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        <span class="keywordflow">if</span> (i % 4 == 3) {</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;            outputFile &lt;&lt; <span class="stringliteral">&quot;#\n\n&quot;</span>;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        }</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    }</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;}</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160; </div>
<div class="line"><a name="l00046"></a><span class="lineno"><a class="line" href="classbottom_surface.html#a0f59d969e5fa357dbed89a3a15519a2c">   46</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classbottom_surface.html#a0f59d969e5fa357dbed89a3a15519a2c">bottomSurface::checkCollision</a>(<span class="keyword">const</span> vector&lt;Vector3D&gt; &amp;droneCover)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="comment">// Checks if any of the Z coordinates is less than the bottom level</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keywordflow">for</span> (<span class="keyword">const</span> <span class="keyword">auto</span> &amp;position : droneCover) {</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <span class="keywordflow">if</span> (position[2] &lt; bottomLevel_) {</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        }</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    }</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160; </div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;}</div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="aclassbottom_surface_html_a0f59d969e5fa357dbed89a3a15519a2c"><div class="ttname"><a href="classbottom_surface.html#a0f59d969e5fa357dbed89a3a15519a2c">bottomSurface::checkCollision</a></div><div class="ttdeci">bool checkCollision(const std::vector&lt; Vector3D &gt; &amp;droneCover) const override</div><div class="ttdoc">Checks if in the next step of movement will be collision with the bottom.</div><div class="ttdef"><b>Definition:</b> <a href="bottom_surface_8cpp_source.html#l00046">bottomSurface.cpp:46</a></div></div>
<div class="ttc" id="aclass_vector_html"><div class="ttname"><a href="class_vector.html">Vector&lt; double, 3 &gt;</a></div></div>
<div class="ttc" id="aclassbottom_surface_html_abd43b419dc9f833e96fc5b7f6674b39b"><div class="ttname"><a href="classbottom_surface.html#abd43b419dc9f833e96fc5b7f6674b39b">bottomSurface::draw</a></div><div class="ttdeci">void draw(const std::string &amp;filename) const override</div><div class="ttdoc">Saves the bottom coordinates to a result file.</div><div class="ttdef"><b>Definition:</b> <a href="bottom_surface_8cpp_source.html#l00026">bottomSurface.cpp:26</a></div></div>
<div class="ttc" id="abottom_surface_8hh_html"><div class="ttname"><a href="bottom_surface_8hh.html">bottomSurface.hh</a></div></div>
<div class="ttc" id="aclassbottom_surface_html_a0ce3f995ccb6c47d41765aa99c3a45b6"><div class="ttname"><a href="classbottom_surface.html#a0ce3f995ccb6c47d41765aa99c3a45b6">bottomSurface::bottomSurface</a></div><div class="ttdeci">bottomSurface()</div><div class="ttdoc">Constructor for bottomSurface class.</div><div class="ttdef"><b>Definition:</b> <a href="bottom_surface_8cpp_source.html#l00005">bottomSurface.cpp:5</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_167790342fb55959539d550b874be046.html">project</a></li><li class="navelem"><a class="el" href="dir_f77a644fded742ea05ed17fa0fdf6fe1.html">src</a></li><li class="navelem"><a class="el" href="bottom_surface_8cpp.html">bottomSurface.cpp</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.17 </li>
  </ul>
</div>
</body>
</html>
